{Handler} = require('./..')._test

# helper to implementation the details of the test
test = (data) ->
  module.exports[data.expr] = (nuTest) ->
    hanlder = new Handler null, path: data.expr
    for path in (data.pass or [])
      nuTest.ok hanlder.pathMatches(path), "#{path} does not match #{data.expr}"
    for path in (data.fail or [])
      nuTest.ok not hanlder.pathMatches(path), "#{path} did match #{data.expr} but shouldn't"
    nuTest.done()


# Exact matching

test
  expr: '/'                        # The root path
  pass: [
        '/'                        # exact
        ]
  fail: [
        '/foo'                     # nothing more
        ]

test
  expr: '/foo'                     # Top level path
  pass: [
        '/foo'                     # exact
        ]
  fail: [
        '/foo/'                    # does not match trailing /
        '/foo.xml'                 # does not match extensions
        '/foodasdsadsa'            # does not match any tailing chars
        ]

# Glob-style pattern matching

test
  expr: '/*'                       # Single path segment
  pass: [
        '/foo'                     # one segment
        '/foo.bar'                 # dot's ok
        '/foo%2Fbar'               # escaped forward slash
        ]
  fail: [
        '/'                        # not enough segments
        '/foo/bar'                 # too many segments
        ]

test
  expr: '/*/bar/*'                 # Two single path segments
  pass: [
        '/foo/bar/baz'
        ]
  fail: [
        '/foo'                     # not enough segments
        '/foo/bar/baz/boom'        # too many segments
        ]


test
  expr: '/**'                      # Two single path segments
  pass: [
        '/foo'                     # one segment
        '/foo/bar/baz'             # many segments
        ]
  fail: [
        '/'                        # not enough segments
        ]

test
  expr: '/foo/**/bar'
  pass: [
        '/foo/baz/bar'
        '/foo/baz/boom/bar'        # many segments
        ]
  fail: [
        '/foo/something/something'
        '/foo/bar'                 # not enough segments
        ]

# Unicode

test
  expr: '/föö'
  pass: [
        '/f%C3%B6%C3%B6'
        ]
